{---------------------   -----------------------------------}
procedure fadeout; assembler;
asm
  les di,v_buffer
  xor cx,cx
 @yloop:
  mov ax,320
  mul cx
  mov bx,20 {65}
 @xloop:
  push ax
  add ax,bx
  mov di,ax
  mov si,ax
  xor ah,ah
  xor dx,dx
  mov al,es:[si]
  add dx,ax
  mov al,es:[si+318]
  add dx,ax
  mov al,es:[si+640]
  add dx,ax
  mov al,es:[si+321]
  add dx,ax
  shr dx,2
  jz @skip
  dec dl
 @skip:
  mov [es:di],dl
  pop ax
  inc bx
  cmp bx,319 {270}
  jne @xloop
  inc cx
  cmp cx,199 {175}
  jne @yloop
end;

const
xcentre:integer=100;
ycentre:integer=150;
{//p楤yp p p py  業p.
//pp:
//          x - p X 業p p,
//          y - p Y 業p p,
//          nAngle - y p( pyc),
//          nScale - c⠡,
//          lpImage - y⥫  p,
//          nWidth - p p,
//          nHeight - c p.}
procedure RotateBitmap(x,y,nAngle,nScale:integer;lpImage:pointer;nWidth,nHeight:integer;where:word);
var
ddx,ddy,d2x,d2y:integer;
i,j:integer;
label vloop,hloop;
begin

   {//c塞 p  c⭮ cc⥬ p.
   //p right  down.
   // pc   p쭮  ⭮襭  c p.}
   ddx:=round(((trunc(cos(nAngle*3.14/180)*360))*nScale)/nWidth);
   ddy:=round(((trunc(sin(nAngle*3.14/180)*360))*nScale)/nHeight);

   d2x:=round(((trunc(cos(nAngle*3.14/180+3.14/2)*360*1.2))*nScale)/nWidth);
   d2y:=round(((trunc(sin(nAngle*3.14/180+3.14/2)*360*1.2))*nScale)/nHeight);

   {//p 業p p饭 p.}
   i:=x-ddx*xcentre-d2x*ycentre;
   j:=y-ddy*xcentre-d2y*ycentre;

   asm

        push ds

        mov ax,word ptr lpImage+2
        mov ds,ax                    {ds-c pc p.}

        mov ax,where
        mov es,ax
        xor di,di                    {es:di - y⥫  .}

        mov ax,[ddx]
        mov si,ax                   {si=ddx.}

        mov cx,200                  {p p  c.}
   vloop:
        push cx
        mov ax,[i]                  {p X,Y  c室 p.}
        mov dx,[j]

        mov cx,320                  {c p  c.}
   hloop:
        add ax,si                   {稢 祭 right-p.}
        add dx,[ddy]
        mov bl,ah                   {bx = 256*y+x}
        mov bh,dh
        mov bl,[ds:bx]
        mov [es:di],bl              {py c  .}
        inc di

        loop hloop

        mov ax,d2x
        mov dx,d2y

        add i,ax
        add j,dx
        pop cx
        loop vloop
        pop ds
   end;

end;

procedure RotateBitmapCool(x,y,nAngle,nScale:integer;lpImage:pointer;nWidth,nHeight:integer;where:word);
var
ddx,ddy,d2x,d2y:integer;
i,j:integer;
label vloop,hloop;
begin

   {//c塞 p  c⭮ cc⥬ p.
   //p right  down.
   // pc   p쭮  ⭮襭  c p.}
   ddx:=round(((round(cos(nAngle*3.14159265/180)*360))*nScale)/nWidth);
   ddy:=round(((round(sin(nAngle*3.14159265/180)*360))*nScale)/nHeight);

   d2x:=round(((round(cos(nAngle*3.14159265/180+3.14159265/2)*360*1.2))*nScale)/nWidth);
   d2y:=round(((round(sin(nAngle*3.14159265/180+3.14159265/2)*360*1.2))*nScale)/nHeight);

   {//p 業p p饭 p.}
   i:=x-ddx*xcentre-d2x*ycentre;
   j:=y-ddy*xcentre-d2y*ycentre;

   asm
        push ds

        mov ax,word ptr lpImage+2
        mov ds,ax                    {ds-c pc p.}

        mov ax,where
        mov es,ax
        xor di,di                    {es:di - y⥫  .}

        mov ax,[ddx]
        mov si,ax                   {si=ddx.}

        mov cx,200                  {p p  c.}
   vloop:
        push cx
        mov ax,[i]                  {p X,Y  c室 p.}
        mov dx,[j]

        mov cx,320                  {c p  c.}
   hloop:
        add ax,si                   {稢 祭 right-p.}
        add dx,[ddy]
        mov bl,ah                   {bx = 256*y+x}
        mov bh,dh
        mov bl,[ds:bx]
        mov [es:di],bl              {py c  .}
        inc di

        loop hloop

        mov ax,d2x
        mov dx,d2y

        add si,2 { ᪠ }

        add i,ax
        add j,dx
        pop cx
        loop vloop
        pop ds
   end;

end;



Procedure Putpixel_ANY (X,Y : Integer; Col : Byte; where:word);
BEGIN
  Asm
    push    ds
    push    es
    mov     ax,[where]
    mov     es,ax
    mov     bx,[X]
    mov     dx,[Y]
    push    bx                      {; and this again for later}
    mov     bx, dx                  {; bx = dx}
    mov     dh, dl                  {; dx = dx * 256}
    xor     dl, dl
    shl     bx, 6                   {; bx = bx * 64}
    add     dx, bx                  {; dx = dx + bx (ie y*320)}
    pop     bx                      {; get back our x}
    add     bx, dx                  {; finalise location}
    mov     di, bx
    {; es:di = where to go}
    mov     ah, [Col]
    mov     es:[di],ah
    pop     es
    pop     ds
  End;
END;

function HiLight:boolean;
VAR
loop1,loop2:integer;
    Tmp : Array [1..3] of byte;
    ifok: boolean;
label trt;
BEGIN
{trt:}
ifok:=true;
    {vRetrace;}
    For loop2:=0 to 255 do BEGIN
      Getrgb (loop2,Tmp[1],Tmp[2],Tmp[3]);
      If Tmp[1]<63 then
      begin
            inc (Tmp[1]);
            ifok:=false;
      end;
      If Tmp[2]<63 then
      begin
            inc (Tmp[2]);
            ifok:=false;
      end;
      If Tmp[3]<63 then
      begin
            inc (Tmp[3]);
            ifok:=false;
      end;
      Setrgb (loop2,Tmp[1],Tmp[2],Tmp[3]);
    END;
    hilight:=ifok;
{if not(ifok) then goto trt;}
END;

procedure FlipTrans(From:word;Into:word;Trans:word);assembler;
asm
        push DS
        mov bx,63999
@cicle:
        mov ax,from
        mov ds,ax
        mov cx,[bx]

        mov ax,into
        mov ds,ax
        cmp cx,trans
        je @skipit
        mov [bx],cx
@skipit:
        dec bx
        cmp bx,0
        jne @cicle
        pop ds
end;

Procedure SetPalette(Var P);

Var
  i : Integer;
  PSeg, pOfs : Word;

Begin
  PSeg := Seg(P);
  POfs := Ofs(P);
  For i := 0 to 255 do
    SetRGB(i, Mem[PSeg:POfs+i*3], Mem[PSeg:POfs+i*3+1], Mem[PSeg:POfs+i*3+2]);
End;


                     { 㧪 BMP'誨  ࠩ }
Procedure loadpicture(x,y:word;filename:string;var buffer:picturetype);
label 11, 21;
var
fil:file of byte;
y1,x1:integer;
colo:byte;
mtv:byte;
begin
i:=1;
mtv:=0;
assign(fil,filename);
reset(fil);
seek(fil,1078);

y1:=1+x;
11:
x1:=1;
21:
read(fil,buffer[i]);
inc(i);
x1:=x1+1;
gotoxy(1,3);
case mtv of
0:write('Preloading...\');
1:write('Preloading...-');
2:write('Preloading.../');
3:write('Preloading...|');
end;
inc(mtv,1);
if mtv>3 then mtv:=0;
if x1<=1+x then goto 21;
y1:=y1-1;
if y1>=1+1 then goto 11;
y1:=ioresult;
close(fil);
y1:=ioresult;
end;

                        { ⪠   }
procedure clearbuf;
begin
asm
cli
end;
memW[0:$41A]:=memW[0:$41c];
asm
sti
end;
end;

                        { 뢠   BMP'誨 }
procedure readpal(F:string);
var
fil:file of byte;
a,i,j,y1,x1:integer;
colo,r,g,b,res:byte;
begin
assign(fil,F);
reset(fil);

seek(fil,54);
for x1:=0 to 255 do
begin
     read(fil,b);
     read(fil,g);
     read(fil,r);
     read(fil,res);
     setrgb(x1,r shr 2,g shr 2,b shr 2);
end;
close(fil);
end;

                { 뢮 ࠩ, 㦥  BMP'誨 }
procedure BMP (x,y,x2,y2:integer;cut:byte;var buffer:picturetype);
label
1,2;
var
y1,x1:integer;
colo:byte;
begin
i:=1;

y1:=y+y2;
1:
x1:=x;
2:

colo:=buffer[i];
inc(i,1);
if (colo<>cut) {and (colo<>128)} then putpixel(x1,y1,colo);
x1:=x1+1;

if x1<=x+x2 then goto 2;

y1:=y1-1;
if y1>=y+1 then goto 1;
end;

var
watercoff:integer;

{ 窠 }
Procedure Water(From:word;InTo:word);
Var
j,x,y:integer;
Costable:array [0..319] of integer;
BEGIN
 {repeat}
   for J:=0 to 319 do CosTable[J]:=Round(Cos((WaterCoff+J)*PI*2/320*8)*3);
   for Y:=3 to 196 do
     for X:=3 to 316 do
       mem[InTo:x+((y shl 8)+(y shl 6))]:=mem[From:320*(Y+CosTable[y])+X+CosTable[x]];
   Inc(WaterCoff);
{ until KeyPressed;
 ClearBuf;}
END;

{  }
Procedure Boil(y1,y2,x1,x2,where:word);
Var
i,j:word;
h:byte;
BEGIN
for i:=y1 to y2 do for j:=x1 to x2 do
begin
    h:=(mem[where:j+(((i+1) shl 8)+((i+1) shl 6))]+mem[where:j+(((i-1) shl 8)+((i-1) shl 6))]+
       mem[where:1+j+((i shl 8)+(i shl 6))]+mem[where:j+((i shl 8)+(i shl 6))-1]) div 4+1;
    asm
    cmp h,255
    je @to0
    jmp @allok
    @to0:
    mov h,0
    @allok:
    end;
    mem[where:j+((i shl 8)+(i shl 6))]:=h;
end;
END;

Procedure Puttpixel (X,Y : Integer; Col : Byte; where:word);
  { This puts a pixel on the screen by writing directly to memory. }
BEGIN
  Asm
    push    ds
    push    es
    mov     ax,[where]
    mov     es,ax
    mov     bx,[X]
    mov     dx,[Y]
    push    bx                      {; and this again for later}
    mov     bx, dx                  {; bx = dx}
    mov     dh, dl                  {; dx = dx * 256}
    xor     dl, dl
    shl     bx, 6                   {; bx = bx * 64}
    add     dx, bx                  {; dx = dx + bx (ie y*320)}
    pop     bx                      {; get back our x}
    add     bx, dx                  {; finalise location}
    mov     di, bx
    {; es:di = where to go}
    xor     al,al
    mov     ah, [Col]
    mov     es:[di],ah
    pop     es
    pop     ds
  End;
END;
